<?php

namespace FiloBlu\ExtMagentoWidget\Plugin\Magento\Cms\Helper;

class Page {

    protected $_customerSession;
    protected $request;
    protected $_page;
    protected $_storeManager;
    protected $_context;
    protected $_customerUrl;
    protected $response;

    public function __construct(
    \Magento\Customer\Model\Session $customerSession,
    \Magento\Framework\App\Request\Http $request,
    \Magento\Cms\Model\Page $page,
    \Magento\Store\Model\StoreManagerInterface $storeManager,
    \Magento\Framework\App\Http\Context $context,
    \Magento\Customer\Model\Url $customerUrl,
    \Magento\Framework\App\Response\Http $response
    ) {
        $this->_customerSession = $customerSession;
        $this->request = $request;
        $this->_page = $page;
        $this->_storeManager = $storeManager;
        $this->_context = $context;
        $this->_customerUrl = $customerUrl;
        $this->response = $response;
    }

    public function afterPrepareResultPage(\Magento\Cms\Helper\Page $subject, $result) {

        if ($result && $arrayCustomerGroup = $this->_page->getCustomerGroup()) {

            $arrayCustomerGroup = explode(",", $arrayCustomerGroup);
            $_currentCustomerGroupId = "-1";

            if ($this->_context->getValue(\Magento\Customer\Model\Context::CONTEXT_AUTH)) {
                $_currentCustomerGroupId = "-2,";
                $_currentCustomerGroupId = $_currentCustomerGroupId . $this->_customerSession->getCustomer()->getGroupId();
            }

            $_currentCustomerGroupIdArray = explode(",", $_currentCustomerGroupId);


            # if page is visible only for logged users and current user is not logged in, redirect to login page with referer param
            if (in_array("-2", $arrayCustomerGroup) && $_currentCustomerGroupId == "-1") {
                $url = $this->_storeManager->getStore()->getCurrentUrl();
                $this->response->setRedirect($this->_customerUrl->getLoginUrl());
                $this->response->sendResponse();
                exit;
            }

            $found = false;

            foreach ($_currentCustomerGroupIdArray as $groupIdVal) {
                if (in_array($groupIdVal, $arrayCustomerGroup)) {
                    $found = true;
                }
            }

            if ($found) {
                return $result;
            } else {
                return null;
            }
        } else {
            return $result;
        }
    }

}
